#include "iir.h"
#include "math.h"
//#include <stdio.h>

void iir_1_1_plain (float *source, float *dest, int size)
{
  float a = 0.6, b = 0.4;
  int i;
  float *sp = source, *dp = dest;
  float y = 0.0;
  for (i = size; i > 0; i --)
  {
    y = *sp * a + y * b;
    *dp = y;
    sp ++;  dp ++;
  }
}

void iir_1_1_vec (float *source, float *dest, int size)
{
  typedef int v4sf __attribute__ ((mode(V4SF)));

  int i;
  float a = 0.6, b = 0.4;
  float __attribute__ ((aligned (16))) aaaa_arr[] = {a, a, a, a};
  v4sf aaaa = * (v4sf *) &aaaa_arr;
  float __attribute__ ((aligned (16))) b____arr[] = {b, 0, 0, 0};
  v4sf b___ = * (v4sf *) &b____arr;
  float __attribute__ ((aligned (16))) _b_b_arr[] = {0, b, 0, b};
  v4sf _b_b = * (v4sf *) &_b_b_arr;
  float __attribute__ ((aligned (16))) __bB_arr[] = {0, 0, b, b*b};
  v4sf __bB = * (v4sf *) &__bB_arr;
  float __attribute__ ((aligned (16))) zero_arr[] = {0, 0, 0, 0};
  v4sf zero = * (v4sf *) &zero_arr;
  float *sp = source, *dp = dest;
  v4sf s = zero, s2;

  for (i = size/4; i > 0; i --)
  {
    s =   __builtin_ia32_loadaps (sp) * aaaa
        + __builtin_ia32_shufps (s, s, select (3, 0, 0, 0)) * b___;
    s += __builtin_ia32_shufps (s, s, select (0, 0, 0, 2)) * _b_b;
    s += __builtin_ia32_shufps (s, s, select (0, 0, 1, 1)) * __bB;

    __builtin_ia32_storeaps (dp, s);
    sp += 4;  dp += 4;
  }
}
