#include "iir.h"
#include "math.h"

void iir_8_5_plain (float *source, float *dest, int size)
{
  int i;
  float a0 = 0.08, a1 = 0.07, a2 = 0.06, a3 = 0.05, a4 = 0.04, a5 = 0.03, a6 = 0.02, a7 = 0.01;//8a
  float	b1 = 0.05, b2 = 0.04, b3 = 0.03, b4 = 0.02, b5 = 0.01;//5b

  float *sp = source, *dp = dest;
  float y6 = 0.0, y5 = 0.0, y4 = 0.0, y3 = 0.0, y2 = 0.0, y1 = 0.0;//6y
  for (i = size; i > 0; i --)
  {
    y6 = sp[0] * a0 + sp[-1] * a1 + sp[-2] * a2 + sp[-3] * a3 + sp[-4] * a4 + sp[-5] * a5 + sp[-6] * a6 + sp[-7] * a7 + y5 * b1 + y4 * b2 + y3 * b3 + y2 * b4 + y1 * b5;
    *dp = y6;
    y1 = y2;  y2 = y3; y3 = y4; y4 = y5; y5 = y6;
    sp ++;  dp ++;
  }
}

void iir_8_5_vec (float *source, float *dest, int size)
{
}
